package com.jdbernard.timeanalyzer.categorizationplans;

import com.jdbernard.timeanalyzer.categories.Category;
import com.jdbernard.timeanalyzer.events.Event;

import java.util.List;
import java.util.Map;

public abstract class CategorizationPlan {

    public CategorizationPlan() {}
    public CategorizationPlan(Closure newCatSetupFun) {
        newCategorySetupFun = newCatSetupFun }

    protected Closure newCategorySetupFun

    protected void setupNewCategory(Category cat) {
        if (newCategorySetupFun) newCategorySetupFun(cat) }


    public abstract boolean deservesNewCategory(Event event, List<Event> existingEvents)
    public abstract Category newCategory(Event event, List<Event> existingEvents)
    public abstract List<Event> findEventsToRecategorize(Event event, List<Event> existingEvents)
}
