package com.jdbernard.timeanalyzer.categorizationplans

import com.jdbernard.timeanalyzer.categories.Category
import com.jdbernard.timeanalyzer.categories.TimeIntervalCategory
import com.jdbernard.timeanalyzer.events.Event

import org.joda.time.DateTime
import org.joda.time.Interval
import org.joda.time.Period

public class DailyCategorizationPlan extends CategorizationPlan {

    public DailyCategorizationPlan() {}
    public DailyCategorizationPlan(Closure newCatSetupFun) {
        super(newCatSetupFun) }

    boolean deservesNewCategory(Event event, List<Event> existingEvents) {
        Interval fullDay = new Interval(
            event.start.toDateMidnight(), Period.days(1))
        Interval eventIv = new Interval(
            event.start, event.duration)

        return fullDay.contains(eventIv) }

    Category newCategory(Event event, List<Event> existingEvents) {
        Interval fullday = new Interval(
            event.start.toDateMidnight(), Period.days(1))

        Category newCat = new TimeIntervalCategory(
            event.start.toString("EEE, MMM dd"), fullday)

        setupNewCategory(newCat)

        return  newCat }

    List<Event> findEventsToRecategorize(Event event,
    List<Event> existingEvents) {
        Interval fullday = new Interval(
            event.start.toDateMidnight(), Period.days(1))
        
        return existingEvents.findAll {
            Interval iv = new Interval(it.start, it.duration)
            fullday.contains(iv) } }
}
