package com.jdbernard.timeanalyzer.categorizationplans

import com.jdbernard.timeanalyzer.categories.Category
import com.jdbernard.timeanalyzer.categories.DescriptionBasedCategory
import com.jdbernard.timeanalyzer.events.Event

public class DescriptionBasedCategorizationPlan extends CategorizationPlan {

    public DescriptionBasedCategorizationPlan() {}
    public DescriptionBasedCategorizationPlan(Closure newCatSetupFun) {
        super(newCatSetupFun) }

    public boolean deservesNewCategory(Event event, List<Event> existingEvents) {
        def desc = event.description.replaceAll(/\p{Punct}/, '').toLowerCase()
        return existingEvents.any {
            it.description.replaceAll(/\p{Punct}/, '').toLowerCase() == desc } }

    public Category newCategory(Event event,
    List<Event> existingEvents) {
        def newCat = new DescriptionBasedCategory(event.description)
        setupNewCategory(newCat)
        return newCat }

    public List<Event> findEventsToRecategorize(Event event,
    List<Event> existingEvents) {
        def desc = event.description.replaceAll(/\p{Punct}/, '').toLowerCase()
        return existingEvents.findAll {
            it.description.replaceAll(/\p{Punct}/, '').toLowerCase() == desc } }

}
