package com.jdbernard.timeanalyzer.categorizationplans

import com.jdbernard.timeanalyzer.categories.Category
import com.jdbernard.timeanalyzer.categories.TwoLevelCategory
import com.jdbernard.timeanalyzer.events.Event

public class TwoLevelCategorizationPlan extends CategorizationPlan {

    private static final def TWO_LEVEL_PATTERN = ~/(.+?):(.*)/

    public TwoLevelCategorizationPlan() {}
    public TwoLevelCategorizationPlan(Closure newCatSetupFun) {
        super(newCatSetupFun) }

    public boolean deservesNewCategory(Event event, List<Event> el) {
        return event ==~ TWO_LEVEL_PATTERN }

    public Category newCategory(Event event, List<Event> el) {
        def m = event.description =~ TWO_LEVEL_PATTERN
        def newCat = new TwoLevelCategory(m[0][1])
        setupNewCategory(newCat)
        return newCat }

    public List<Event> findEventsToRecategorize(Event event,
    List<Event> existingEvents) {
        def m = event.description =~ TWO_LEVEL_PATTERN
        return existingEvents.findAll { it.description ==~ /${m[0][1]}:.*/ } }
}
